.test: &test
  stage: test
  before_script:
    - apt update -y
    - apt install -y clang
    - curl -LsSf https://get.nexte.st/latest/linux | tar zxf - -C ${CARGO_HOME:-~/.cargo}/bin
  script:
    - cargo build --verbose
    - cargo nextest run --workspace
    # - cargo test --doc --verbose --workspace
  artifacts:
    when: always
    paths:
      - target/nextest/default/junit.xml
    reports:
      junit: target/nextest/default/junit.xml
  needs: []

stages:
  - lint
  - test

clippy:
  stage: lint
  image: rust:latest
  before_script:
    - rustup component add clippy
    - cargo install gitlab_clippy
  script:
    - cargo clippy --all
  after_script:
    - cargo clippy --all --message-format=json | gitlab-clippy > gl-code-quality-report.json
  artifacts:
    reports:
      codequality: gl-code-quality-report.json
    expire_in: 1 week
  rules:
    - if: '$CODE_QUALITY_DISABLED'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "push"'


test-rust-latest:
  image: rust:latest
  <<: *test
  cache:
    key: cache
    paths:
        - target/

test-rust-nightly:
  image: rustlang/rust:nightly
  <<: *test
  cache:
    key: nightly-cache
    paths:
        - target/
  allow_failure: true
